#ifndef COMMUNICATION_H_
#define COMMUNICATION_H_

#include "communication/TCPSocket.h"
#include "communication/UDPSocket.h"

/**
 * Trieda Communication umoznuje komunikaciu po sieti prostrednictvom protokolu TCP alebo UDP.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class Communication
{
private:
	TCPSocket *tcpSocket;
	UDPSocket *udpSocket;
public:
	Communication(unsigned char protocol);
	bool setServer(unsigned short port, unsigned long address);
	bool send(char *sendingMessage);
	bool select(int seconds, int microseconds);
	bool receive(char *receivingMessage, int receivingMessageSize);
	virtual ~Communication();
};

#endif /* COMMUNICATION_H_ */
