#ifndef TCPSOCKET_H_
#define TCPSOCKET_H_

#ifdef WIN32
#include <Winsock2.h>
#else
#include <arpa/inet.h>
#endif

/**
 * Trieda TCPSocket umoznuje komunikaciu po sieti prostrednictvom protokolu TCP.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class TCPSocket
{
private:
#ifdef WIN32
	SOCKET fileDescriptor;
#else
	int fileDescriptor;
#endif
public:
	TCPSocket();
	bool connect(unsigned short port, unsigned long address);
	bool send(char *sendingMessage);
	bool select(int seconds, int microseconds);
	bool receive(char *receivingMessage, int receivingMessageSize);
	virtual ~TCPSocket();
};

#endif /* TCPSOCKET_H_ */
