#ifndef WORLDMODEL_H_
#define WORLDMODEL_H_

#include "worldmodel/Ball.h"
#include "worldmodel/FixedObject.h"
#include "worldmodel/Me.h"
#include "worldmodel/Player.h"

#define F1R 0
#define G1R 1
#define G2R 2
#define F2R 3
#define F2L 4
#define G2L 5
#define G1L 6
#define F1L 7

/**
 * Trieda WorldModel predstavuje model sveta (ihrisko) a umoznuje transformovat data zo sady perceptorov a spatne transformovat data do sady efektorov.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class WorldModel
{
private:
	float playTime;
	char playMode[100];
	FixedObject *fixedObject;
	Me *me;
	int playerCount;
	Player *player;
	int ballCount;
	Ball *ball;
public:
	WorldModel(char *team, int id, float playGroundLength, float playGroundWidth, float goalWidth, float goalHeight);
	void transform(PerceptorSet *perceptorSet);
	void reverseTransform(EffectorSet *effectorSet);
	float getPlayTime();
	char *getPlayMode();
	FixedObject *getFixedObject(int index);
	Me *getMe();
	int getPlayerCount();
	Player *getPlayer(int index);
	int getBallCount();
	Ball *getBall(int index);
	virtual ~WorldModel();
};

#endif /* WORLDMODEL_H_ */
