#include "Beam.h"
#include <stdio.h>

/**
 * Konstruktor Beam() inicializuje prvky, ktore budu potrebne na zlozenie casti posielanej spravy, ktora bude obsahovat beam efektor.
 */

Beam::Beam()
{
	x = 0;
	y = 0;
	rotation = 0;
}

/**
 * Metoda set() nastavi prvky, ktore budu potrebne na zlozenie casti posielanej spravy, ktora bude obsahovat beam efektor.
 * @param x - X-ova suradnica agenta.
 * @param y - Y-ova suradnica agenta.
 * @param rotation - Uhol natocenia agenta.
 */

void Beam::set(float x, float y, float rotation)
{
	this->x = x;
	this->y = y;
	this->rotation = rotation;
}

/**
 * Metoda compose() zlozi z prvkov cast posielanej spravy, ktora bude obsahovat beam efektor.
 * @param sendingMessage - Vystupna cast posielanej spravy, ktora bude obsahovat beam efektor.
 * @param sendingMessageSize - Maximalna dlzka casti posielanej spravy, ktora bude obsahovat beam efektor.
 * @return Dlzka casti posielanej spravy, ktora bude obsahovat beam efektor.
 */

int Beam::compose(char *sendingMessage, int sendingMessageSize)
{
#ifdef WIN32
	return sprintf_s(sendingMessage, sendingMessageSize, "(beam %1.2f %1.2f %1.2f)", x, y, rotation);
#else
	return sprintf(sendingMessage, "(beam %1.2f %1.2f %1.2f)", x, y, rotation);
#endif
}
