#include "HingeJoint.h"
#include <stdio.h>
#include <string.h>

/**
 * Konstruktor HingeJoint() inicializuje prvky, ktore budu potrebne na zlozenie casti posielanej spravy, ktora bude obsahovat hingejoint efektor.
 */

HingeJoint::HingeJoint()
{
	name[0] = '\0';
	angularVelocity = 0;
}

/**
 * Metoda set() nastavi prvky, ktore budu potrebne na zlozenie casti posielanej spravy, ktora bude obsahovat hingejoint efektor.
 * @param name - Nazov agentovho klbu.
 * @param angularVelocity - Uhlova rychlost agentovho klbu.
 */

void HingeJoint::set(char *name, float angularVelocity)
{
#ifdef WIN32
	strcpy_s(this->name, name);
#else
	strcpy(this->name, name);
#endif
	this->angularVelocity = angularVelocity;
}

/**
 * Metoda compose() zlozi z prvkov cast posielanej spravy, ktora bude obsahovat hingejoint efektor.
 * @param sendingMessage - Vystupna cast posielanej spravy, ktora bude obsahovat hingejoint efektor.
 * @param sendingMessageSize - Maximalna dlzka casti posielanej spravy, ktora bude obsahovat hingejoint efektor.
 * @return Dlzka casti posielanej spravy, ktora bude obsahovat hingejoint efektor.
 */

int HingeJoint::compose(char *sendingMessage, int sendingMessageSize)
{
#ifdef WIN32
	return sprintf_s(sendingMessage, sendingMessageSize, "(%s %1.2f)", name, angularVelocity);
#else
	return sprintf(sendingMessage, "(%s %1.2f)", name, angularVelocity);
#endif
}
