#include "FRP.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor FRP() vytvori podtriedy, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje FRP_perceptor.
 */

FRP::FRP()
{
	n = new N();
	c = new C();
	f = new F();
}

/**
 * Metoda decompose() rozlozi na prvky podtried cast prijatej spravy, ktora obsahuje FRP_perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje FRP_perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje FRP_perceptor.
 */

int FRP::decompose(char *receivingMessage)
{
	int i = 5;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			char *receivingMessage3 = receivingMessage2 + 1;
			if (strncmp(receivingMessage3, "n ", 2) == 0)
			{
				i += n->decompose(receivingMessage2);
			}
			else if (strncmp(receivingMessage3, "c ", 2) == 0)
			{
				i += c->decompose(receivingMessage2);
			}
			else if (strncmp(receivingMessage3, "f ", 2) == 0)
			{
				i += f->decompose(receivingMessage2);
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"FRP\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getN() vrati ukazovatel na n perceptor.
 * @return Ukazovatel na n perceptor.
 */

N *FRP::getN()
{
	return n;
}

/**
 * Metoda getC() vrati ukazovatel na c perceptor.
 * @return Ukazovatel na c perceptor.
 */

C *FRP::getC()
{
	return c;
}

/**
 * Metoda getF() vrati ukazovatel na f perceptor.
 * @return Ukazovatel na f perceptor.
 */

F *FRP::getF()
{
	return f;
}

/**
 * Desruktor ~FRP() zrusi podtriedy, ktore boli potrebne na rozlozenie casti prijatej spravy, ktora obsahovala FRP_perceptor.
 */

FRP::~FRP()
{
	delete f;
	delete c;
	delete n;
}
