#ifndef SEE_H_
#define SEE_H_

#include "see/B.h"
#include "see/F1L.h"
#include "see/F1R.h"
#include "see/F2L.h"
#include "see/F2R.h"
#include "see/G1L.h"
#include "see/G1R.h"
#include "see/G2L.h"
#include "see/G2R.h"
#include "see/P.h"

/**
 * Trieda See umoznuje rozlozit cast prijatej spravy, ktora obsahuje See_perceptor.
 * @author Michal Kvetan
 * @version 8.12.11
 */

class See
{
private:
	int pCount;
	P *p;
	int f1lCount;
	F1L *f1l;
	int f1rCount;
	F1R *f1r;
	int f2lCount;
	F2L *f2l;
	int f2rCount;
	F2R *f2r;
	int g1lCount;
	G1L *g1l;
	int g1rCount;
	G1R *g1r;
	int g2lCount;
	G2L *g2l;
	int g2rCount;
	G2R *g2r;
	int bCount;
	B *b;
public:
	See();
	int decompose(char *receivingMessage);
	int getPCount();
	P *getP(int index);
	int getF1LCount();
	F1L *getF1L(int index);
	int getF1RCount();
	F1R *getF1R(int index);
	int getF2LCount();
	F2L *getF2L(int index);
	int getF2RCount();
	F2R *getF2R(int index);
	int getG1LCount();
	G1L *getG1L(int index);
	int getG1RCount();
	G1R *getG1R(int index);
	int getG2LCount();
	G2L *getG2L(int index);
	int getG2RCount();
	G2R *getG2R(int index);
	int getBCount();
	B *getB(int index);
	virtual ~See();
};

#endif /* SEE_H_ */
