#include "Time.h"
#include <iostream>
#include <string.h>

using namespace std;

/**
 * Konstruktor Time() vytvori podtriedu, ktora bude potrebna na rozlozenie casti prijatej spravy, ktora obsahuje time perceptor.
 */

Time::Time()
{
	now = new Now();
}

/**
 * Metoda decompose() rozlozi na prvky podtriedy cast prijatej spravy, ktora obsahuje time perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje time perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje time perceptor.
 */

int Time::decompose(char *receivingMessage)
{
	int i = 6;
	while (receivingMessage[i] != ')')
	{
		if (receivingMessage[i] == '(')
		{
			char *receivingMessage2 = receivingMessage + i;
			if (strncmp(receivingMessage2 + 1, "now ", 4) == 0)
			{
				i += now->decompose(receivingMessage2);
			}
			else
			{
				int j = 1;
				int k = 1;
				do
				{
					switch (receivingMessage2[j])
					{
						case '(':
							k ++;
							break;
						case ')':
							k --;
							break;
					}
					j ++;
				}
				while (k > 0);
				i += j;
				char *perceptor = new char[j + 1];
				memcpy(perceptor, receivingMessage2, j);
				perceptor[j] = '\0';
				cerr << "Agent nepozna \"time\" perceptor: \"" << perceptor << "\"." << endl;
				delete[] perceptor;
			}
		}
		else
		{
			i ++;
		}
	}
	return i + 1;
}

/**
 * Metoda getNow() vrati ukazovatel na now perceptor.
 * @return Ukazovatel na now perceptor.
 */

Now *Time::getNow()
{
	return now;
}

/**
 * Desruktor ~Time() zrusi podtriedu, ktora bola potrebna na rozlozenie casti prijatej spravy, ktora obsahovala time perceptor.
 */

Time::~Time()
{
	delete now;
}
