#include "Rt.h"
#include <stdio.h>

/**
 * Konstruktor Rt() inicializuje prvky, ktore budu potrebne na rozlozenie casti prijatej spravy, ktora obsahuje rt perceptor.
 */

Rt::Rt()
{
	angularAccelerationX = 0;
	angularAccelerationY = 0;
	angularAccelerationZ = 0;
}

/**
 * Metoda decompose() rozlozi na prvky cast prijatej spravy, ktora obsahuje rt perceptor.
 * @param receivingMessage - Cast prijatej spravy, ktora obsahuje rt perceptor.
 * @return Dlzka casti prijatej spravy, ktora obsahuje rt perceptor.
 */

int Rt::decompose(char *receivingMessage)
{
	int j;
	for (j = 7; receivingMessage[j] != ' '; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + 4, "%f", &angularAccelerationX);
#else
	sscanf(receivingMessage + 4, "%f", &angularAccelerationX);
#endif
	int i = j + 1;
	for (j = i + 3; receivingMessage[j] != ' '; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + i, "%f", &angularAccelerationY);
#else
	sscanf(receivingMessage + i, "%f", &angularAccelerationY);
#endif
	i = j + 1;
	for (j = i + 3; receivingMessage[j] != ')'; j ++)
	{
	}
#ifdef WIN32
	sscanf_s(receivingMessage + i, "%f", &angularAccelerationZ);
#else
	sscanf(receivingMessage + i, "%f", &angularAccelerationZ);
#endif
	return j + 1;
}

/**
 * Metoda getAngularAccelerationX() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje rt perceptor.
 * @return Uholove zrychlenie vzhladom k x-ovej osi.
 */

float Rt::getAngularAccelerationX()
{
	return angularAccelerationX;
}

/**
 * Metoda getAngularAccelerationY() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje rt perceptor.
 * @return Uholove zrychlenie vzhladom k y-ovej osi.
 */

float Rt::getAngularAccelerationY()
{
	return angularAccelerationY;
}

/**
 * Metoda getAngularAccelerationZ() vrati prvok rozlozenej casti prijatej spravy, ktora obsahuje rt perceptor.
 * @return Uholove zrychlenie vzhladom k z-ovej osi.
 */

float Rt::getAngularAccelerationZ()
{
	return angularAccelerationZ;
}
